/////////////////////////////////////////////////////////////////////////////////
//  OpenDuino Fw 1.0 
//
//  Se riceve una chiamata, da un numero presente in rubrica SIM,  chiude il relè e attiva l'uscita open collector2 per 2 secondi.
//
//
//    Sintassi Messaggi di comando(Maiuscole o minuscole indifferenti):
//
//    'bdn OC2 ON'  = Attiva Open collector2 per 2 secondi
//    'bdn OC2 ON C' = Attiva Open collector2 per 2 secondi e risponde con SMS di conferma operazione
//
//    'bdn OC1 ON'  = Attiva Open collector1 permanentemente
//    'bdn OC1 ON C' = Attiva Open collector1 permanentemente e risponde con SMS di conferma operazione
//
//    'bdn OC1 OFF'  = Disattiva Open collector1 permanentemente
//    'bdn OC1 OFF C' = Disattiva Open collector1 permanentemente e risponde con SMS di conferma operazione
//
//
//
//    All'apertura di uno dei 2 contatti Normalmente chiusi invia un SMS di allarme al numero memorizzato come default con il comando:'bdn NEW: +XXXXXXXXXXXX'
//
//    Ingresso In1 = Input1
//    Ingresso In2 = Input2
//
/////////////////////////////////////////////////////////////////////////////////

//GSM Shield for Arduino
//www.open-electronics.org
//this code is based on the example of Arduino Labs.

#include "SIM900.h"
#include <SoftwareSerial.h>
//We don't need the http functions. So we can disable the next line.
//#include "inetGSM.h"
#include "sms.h"
#include "call.h"
#include <EEPROM.h>

// Pin 14: Output Abilita Trasmissione RS485
// Pin 15: Output Relè e Led 2
// Pin 16: Output Open Collector1 e Led 1
// Pin 17: Input Ingresso 1
// Pin 18: Input Ingresso 2
// Pin 19: Output Open Collector2


//We have to create the classes for SMSs and calls.
CallGSM call;
SMSGSM sms;

char smsbuffer[80];
int posizione=0;

boolean input1;
boolean input2;
char stato1='1';
char stato2='1';

byte i;

byte stat=0;
byte tempSMS=0;

char number[18];
byte tempo[3]={0,0,0};





void setup() 
{
 
 pinMode(8,OUTPUT);          // GSM Power UP PIN
 pinMode(9,OUTPUT);          // GSM RESET PIN KEEP LOW
 digitalWrite(9, LOW) ;
 
 pinMode(2, INPUT);
 pinMode(3, OUTPUT);
 pinMode(14,OUTPUT);          // Led Giallo Abilitazione Comunicazione RS485
 pinMode(15,OUTPUT);          // Relè
 pinMode(16,OUTPUT);          // Uscita Open Collector1
 pinMode(17,INPUT);           // Ingresso 2
 pinMode(18,INPUT);           // Ingresso 1
 pinMode(19,OUTPUT);          // Uscita Open Collector2
 
  digitalWrite(2, HIGH) ;     //PullUp su pin 2
  digitalWrite(17, HIGH) ;    //PullUp su ingresso 2
  digitalWrite(18, HIGH) ;    //PullUp su ingresso 1
  
                   for (int i=0;i<12;i++)  // Lampeggio Iniziale Led Giallo
                   {digitalWrite(14, HIGH);
                   delay(10);
                   digitalWrite(14, LOW);
                   delay(30); 
                   }

 
  Serial.begin(9600);
  delay(50); 
  
  //Serial.println("Bastarduino Apricancello");
  //Start configuration of shield with baudrate.
  //For http uses is raccomanded to use 4800 or slower.
        if (gsm.begin(9600))
        Serial.println("\nstatus=READY");
        else 
        { 
          Serial.println("\nstatus=IDLE");
          digitalWrite(9, HIGH) ; // Reset GSM     
	  delay(1800);
	  digitalWrite(9, LOW) ;
        }    
 }; // Fine Setup
 
 

void loop() 
{

  
  //Chekcs status of call
  stat=call.CallStatusWithAuth(number,1,10);
  //If the incoming call is from an authorized number
  //saved on SIM in the positions range from 1 to 10.
  // (number,0,0) makes authorized all numbers calling it
  if(stat==CALL_INCOM_VOICE_AUTH){                                            // Inizio Procedura chiamata ricevuta 
             
                
               digitalWrite(14, HIGH);     // Accende Led Giallo
              
               digitalWrite(15, HIGH) ;    // Chiusura Relè
               digitalWrite(19, HIGH) ;    // Chiusura Open Collector 2
               
              //Hang up the call.
              call.HangUp();
              delay(50);
                    //Serial.print("Chiamata Ricevuta da: ");
                    //Serial.println(number);
                    // Serial.println("");     
                    // delay(50);
                    
                for (int i=0;i<10;i++)          //Lampeggio Ricezione Chiamata da numero autorizzato che tiene anche il relè chiuso per circa 2,5 secondi
                   {digitalWrite(14, LOW);
                   delay(200);
                   digitalWrite(14, HIGH);
                   delay(20);}
           
                                 //delay(1500); 
                                 digitalWrite(19, LOW) ;  // Apertura Open Collector 2
                                 digitalWrite(15, LOW) ;  // Apertura Rele
                                 
                    digitalWrite(14, LOW);    // Spegne Led Giallo

            
  } 
else if(stat==CALL_INCOM_VOICE_NOT_AUTH)      // Procedura in caso di ricezione chiamata da numero non autorizzato(non in SIM nelle posizioni da 1 a 10)
{      
     digitalWrite(14, HIGH);
     //Hang up the call.
     call.HangUp(); 
         delay(60);
         digitalWrite(14, LOW);
          delay(60);
         digitalWrite(14, HIGH);
         delay(60);
         digitalWrite(14, LOW);
     // delay(200);
         
}        // Fine Procedura chiamata ricevuta


  
  ////////////////////////Ricezione comandi SMS////////////////////////
   if(tempo[0]%14==0)    // Tempoorizzazione
       {
 
        posizione = sms.IsSMSPresent(SMS_ALL);      // Ricerca SMS presenti sulla SIM
         delay(50);
        
         if(posizione>0)
         tempSMS = sms.GetAuthorizedSMS(posizione, number, smsbuffer, 30, 1, 10);      // Nel caso ci sia un SMS presente lo elabora prendendo la posizione sulla SIM, 
         else                                                                          // il numero da cui arriva SMS, il testo(smsbuffer), 
         tempSMS = GETSMS_NO_SMS;                                                      // il numero di caratteri letti(sempreminore della dimensione di smsbuffer) e messi nel buffer(30) e verifica se il numero dal quale arriva è autorizzato tra la posizione 1 e 10 della SIM
   

      
       if (tempSMS==GETSMS_AUTH_SMS) {
                 
             digitalWrite(14, HIGH);    //Accende Led Giallo
  
              gsm.begin(9600);
              
                 delay(200);
                 sms.DeleteSMS(posizione);    // Una volta memorizzato su buffer si cancella SMS dalla SIM
                 delay(500);
    

           
               if( (smsbuffer[0]=='b' || smsbuffer[0]=='B') && (smsbuffer[1]=='d' || smsbuffer[1]=='D') && (smsbuffer[2]=='n' || smsbuffer[2]=='N'))      // Operazioni di riconoscimento testo SMS (Preambolo bdn)
                 {      
     
                         if((smsbuffer[4]=='o' || smsbuffer[4]=='O') && (smsbuffer[5]=='c' || smsbuffer[5]=='C'))    // Operazioni Open Collector
                           {
                             
                             if(smsbuffer[6]=='2' && (smsbuffer[9]=='n' || smsbuffer[9]=='N'))      // OC2
                               {
                                 digitalWrite(19, HIGH) ;        
                                 delay(2000); 
                                 digitalWrite(19, LOW) ;
                                 //Serial.print("OC2 Attivato per 2 Secondi");
   
                                 if(smsbuffer[11]=='c' || smsbuffer[11]=='C') // Richiesta di Conferma
                                 { 
                                   sms.SendSMS(number,"bdn: Uscita OC2 Attivata per 2 secondi");
                                   delay(500);}       
                               } 
                               else if( smsbuffer[6]=='1' && (smsbuffer[9]=='n' || smsbuffer[9]=='N'))    // OC1
                                       {
                                        digitalWrite(16, HIGH) ;
                                                                             
                                           if(smsbuffer[11]=='c' || smsbuffer[11]=='C') // Richiesta di Conferma
                                             { 
                                               sms.SendSMS(number,"bdn: Uscita OC1 Attivata"); 
                                             delay(500);} 
                                       }
                                 else if(smsbuffer[6]=='1' && smsbuffer[9]=='f' || smsbuffer[9]=='F')
                                      {
                                       digitalWrite(16, LOW) ;
                                       
                                            if(smsbuffer[12]=='c' || smsbuffer[12]=='C') // Richiesta di Conferma
                                             { 
                                               sms.SendSMS(number,"bdn: Uscita OC1 Disattivata");
                                             delay(500);} 
                                    }
                                    else
                                    { 
                                      sms.SendSMS(number,"bdn: Scusa non ho capito");
                                    delay(500);} 
                           } //Fine Operazioni OC
                          else
                          {
                            sms.SendSMS(number,"bdn: Scusa non ho capito"); 
                          }
                          
                      for (int i = 0; i < 29; i++)    // Pulizia Buffer SMS (Interno a riconoscimento BDN)
                      {smsbuffer[i]=0;        
                      }

                    }     // Fine riconoscimento preambolo 'bdn'

           digitalWrite(14, LOW);
        }                                    
        else if (tempSMS==GETSMS_NOT_AUTH_SMS) 
                { 
                 delay(200);
                 sms.DeleteSMS(posizione);                // Se SMS non è autorizzato viene cancellato comunque
                      for (int i = 0; i < 5; i++)          // Ciclo Lampeggio conferma cancellazione SMS
                      { 
                       digitalWrite(14, LOW);   
                       delay(50);
                       digitalWrite(14, HIGH);   
                       delay(50); 
                      }
                      digitalWrite(14, LOW);    
                }
 
     }                                       // Fine Temporizzazione lettura SMS su SIM
 

///////////////////Ingressi e Allarmi////////////////////
input1=digitalRead(18);
input2=digitalRead(17);


if(input1==1 && stato1=='0')  // read the input pin 17 Porta
{digitalWrite(14, HIGH);
sms.SendSMS(1,"bdn: Allarme1");   // Manda SMS di allarme al numero in prima posizione sulla SIM
delay(900);
digitalWrite(14, LOW);
 stato1='1';//Stato1
} else if(input1==0 && stato1=='1')
        {  
          delay(300);
          if(digitalRead(18)==0)
          stato1='0';//StatoPorta
        }

if(input2==1 && stato2=='0')  // read the input pin 18 Bypass
{digitalWrite(14, HIGH);
sms.SendSMS(1,"bdn: Allarme2");    // Manda SMS di allarme al numero in prima posizione sulla SIM
delay(900);
digitalWrite(14, LOW);
 stato2='1';//Stato2
}
else if(input2==0 && stato2=='1')
        {  
          delay(300);
          if(digitalRead(17)==0)
          stato2='0';//Statobypass
        }
 
  /// ////////////////TIMER
  ++tempo[0];
  if(tempo[0]==250)
           { 
             ++tempo[1];
   
               if(tempo[1]==74)                  // Circa Ogni Ora (tempo[1]==74)
                 { 
                   ++tempo[2];
                   ++tempo[3];

                   if(tempo[2]==24)             // Ogni 24 Ore circa (tempo[2]==24)
                       {	              
                          tempo[2]=0;                     
                        }
                    tempo[1]=0; 
                   }              
             }
 ////////////// Fine Timer 
  
  
};   

                                                          

